#define _CRT_SECURE_NO_WARNINGS

#include <windows.h>
#include <tchar.h>
#include <stdio.h>

//#define ENABLE_KOREAN

int main(int, char*)
{
	wchar_t symbols[16384];
	wchar_t* p(symbols);
	char buffer[65536];
#ifdef ENABLE_KOREAN
	FILE* f = fopen("latin_greek_cyrillic_korean.txt", "w");
#else
	FILE* f = fopen("latin_greek_cyrillic.txt", "w");
#endif
	unsigned int i(0);
	// Latin block
	wchar_t c(32);
	while(c < 127)
		*p++ = c++;
	c = 160;
	while(c < 0x180)
		*p++ = c++;
	// Greek block
	*p++ = 0x37e;
	c = 0x384;
	while(c < 0x38b)
		*p++ = c++;
	*p++ = ++c;
	c = 0x38e;
	while(c < 0x3a2)
		*p++ = c++;
	++c;
	while(c < 0x3cf)
		*p++ = c++;
	// Cyrillic block
	c = 0x401;
	while(c < 0x40d)
		*p++ = c++;
	c = 0x40e;
	while(c < 0x450)
		*p++ = c++;
	c = 0x451;
	while(c < 0x45d)
		*p++ = c++;
	*p++ = 0x45e;
	*p++ = 0x45f;
	c = 0x490;
	while(c < 0x494)
		*p++ = c++;
	*p++ = 0x496;
	*p++ = 0x497;
	c = 0x49a;
	while(c < 0x49e)
		*p++ = c++;
	*p++ = 0x4a2;
	*p++ = 0x4a3;
	c = 0x4ae;
	while(c < 0x4b4)
		*p++ = c++;
	c = 0x4b8;
	while(c < 0x4bc)
		*p++ = c++;
	*p++ = 0x4d8;
	*p++ = 0x4d9;
	*p++ = 0x4e8;
	*p++ = 0x4e9;
#ifdef ENABLE_KOREAN
	c = 0xac00;
	while(c < 0xd7a4)
		*p++ = c++;
#endif
	const int count(p - symbols);
	printf("Size: %d\n", count);
	*p = 0;
	const int bytes(WideCharToMultiByte(CP_UTF8, 0, symbols, count, buffer, 65536, 0, 0));
	fwrite(buffer, sizeof(char), bytes, f);
	fclose(f);
	return 0;
}
