// Helpert for realizing TL (2D) effects

float4 TLParameters;	// x = 1/width, y = 1/height, zw - reserved

// return position from coords in pixels (x - hor, y - vert, z - depth)
float4 TLFromPixels(float3 aPosition)
{
	return float4(
		2 * aPosition.x * TLParameters.x - 1,
		1 - 2 * aPosition.y * TLParameters.y, 
		aPosition.z,
		1
		);
}
float2 TLFromPixels(float2 aPosition)
{
	return float2(
		2 * aPosition.x * TLParameters.x - 1,
		1 - 2 * aPosition.y * TLParameters.y 
		);
}