#include "Inc/PointLight.fx"

float4x4 matWorld;
float4x4 matViewProj;		//  view*proj

struct vsInput
{
	float4 vPos:	POSITION;
	float3 vNormal:	NORMAL;
};

vsDeferLightOutput vsDeferLight(vsInput vIn)
{
	vsDeferLightOutput vOut;
	float4 vTPos = mul(vIn.vPos, matWorld);
	vOut.vPos = mul(vTPos, matViewProj);
	vOut.vTPos =vOut.vPos;
	vOut.vTNormal = vIn.vNormal;
	return vOut;
}


TECH_DEFER_LIGHT_DEFAULT